#include "headers.h"


int main (){
	TRanking1 ranking; //Se declaran las tres estructuras para los rankings
	TRanking2 ranking2;
	TRanking2 ranking3;

	for(int i = 0; i< kNUMRANKING; i++){ //Se inicializan los tres rankings
		ranking[i].nick = "Nadie";
		ranking[i].tiempo = 0;
	}

	for(int i = 0; i< kNUMRANKING; i++){
		ranking2[i].eficacia = 0;
		ranking2[i].nick = "Nadie";
		ranking2[i].numoperaciones = 0;
		ranking2[i].tiempo = 0;
		ranking2[i].puntuacion = 0;
	}

	for(int i = 0; i< kNUMRANKING; i++){
		ranking3[i].eficacia = 0;
		ranking3[i].nick = "Nadie";
		ranking3[i].numoperaciones = 0;
		ranking3[i].tiempo = 0;
		ranking3[i].puntuacion = 0;
	}


	int diferenciaparaunlock1 = 0; //Variables que controlan el logro para los modos y añadidos desbloquables
	float eficaciaparaunlock2 = 0;
	int puntuacionparaunlock3 = 0;
	bool unlock1 = 0; //Variables que controlan si están o no desbloqueados estos modos
	bool unlock2 = 0;
	bool unlock3 = 0;
	int opcionJuego = 0; //Variable que guarda la opción introducida en el menú
	char simboloMenu1 = '#';
	char simboloMenu2 = '*';
	char estiloMenu = simboloMenu1;

	screenInicial(estiloMenu);

	cargarDatos(ranking, ranking2, ranking3, unlock1, unlock2, unlock3);

	if(unlock3 == 0)
		estiloMenu = simboloMenu1;
	else
		estiloMenu = simboloMenu2;

	do{
		opcionJuego = mostrarMenu(estiloMenu,unlock1,unlock2);

		if(opcionJuego == 1){
			diferenciaparaunlock1 = veinteOperaciones(ranking);
			mostrarRanking(ranking,ranking2,ranking3,1,estiloMenu);
			if(diferenciaparaunlock1 <= 60 && unlock1 == 0){
				system("clear");
				cout << "\a" << "¡Has desbloqueado un nuevo modo! Selecciónalo en la pantalla inicial" << endl;
				unlock1 = 1;
				wait (3);
			}
		}

		if(unlock1 == 1 && opcionJuego == 2){
			eficaciaparaunlock2 = operacionesContrarreloj(ranking2);
			mostrarRanking(ranking,ranking2,ranking3,2,estiloMenu);
			if(eficaciaparaunlock2 >= 0.6 && unlock2 == 0){
				system("clear");
				cout << "\a" << "¡Has desbloqueado un nuevo modo! Selecciónalo en la pantalla inicial" << endl;
				unlock2 = 1;
				wait (3);
			}
		}

		if(unlock2 == 1 && opcionJuego == 3){
			puntuacionparaunlock3 = maratonOperaciones(ranking3);
			mostrarRanking(ranking,ranking2,ranking3,3,estiloMenu);
			if(puntuacionparaunlock3 >= 20000 && unlock3 == 0){
				system("clear");
				cout << "\a" << "¡Has desbloqueado un nuevo icono de menú!" << endl;
				unlock3 = 1;
				estiloMenu = simboloMenu2;
				wait (3);
			}
		}

		if((unlock1 == 0 && opcionJuego == 2) || (unlock1 == 1 && unlock2 == 0 && opcionJuego == 3) || (unlock2 == 1 && opcionJuego == 4)){
			menuRanking(ranking, ranking2, ranking3, unlock1, unlock2,estiloMenu);
		}

		if((unlock1 == 0 && opcionJuego == 3) || (unlock1 == 1 && unlock2 == 0 && opcionJuego == 4) || (unlock2 == 1 && opcionJuego == 5)){
			guardarDatos(ranking, ranking2, ranking3, unlock1, unlock2, unlock3);
			cout << "¡Gracias por jugar! ^-^" << endl;
			wait (2);
		}
	}while((unlock1 == 0 && opcionJuego != 3) || (unlock1 == 1 && unlock2 == 0 && opcionJuego != 4) || (unlock2 == 1 && opcionJuego != 5));

}

void wait (int segundos)
{
	clock_t finespera;
	finespera = clock() + segundos * CLOCKS_PER_SEC ;
	while (clock() < finespera) {}
}

void screenInicial(char estiloMenu){
	system("clear");
	for(int i=0;i<60; i++)
		cout << estiloMenu;
	cout << endl;
	cout << "                   Ejercicio mental...ado" << endl << endl;
	cout << "            Calcula como en primaria, pero rápido" << endl;
	for(int i=0;i<60; i++)
		cout << estiloMenu;
	cout << endl;

	wait (5);
}

int mostrarMenu(char estiloMenu,bool unlock1, bool unlock2){
	system("clear");

	int opcion = 0;
	if(unlock1 == 0){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
		cout << "Seleccione modo de juego: " << endl;
		cout << "1 - 20 operaciones muy rápidas" << endl;
		cout << "2 - Ranking" << endl;
		cout << "3 - Salida" << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
	}
	if(unlock1 == 1 && unlock2 == 0){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
		cout << "Seleccione modo de juego: " << endl;
		cout << "1 - 20 operaciones muy rápidas" << endl;
		cout << "2 - Operaciones a contrarreloj" << endl;
		cout << "3 - Ranking" << endl;
		cout << "4 - Salida" << endl;
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
	}
	if(unlock2 == 1){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
		cout << "Seleccione modo de juego: " << endl;
		cout << "1 - 20 operaciones muy rápidas" << endl;
		cout << "2 - Operaciones a contrarreloj" << endl;
		cout << "3 - Maratón de operaciones" << endl;
		cout << "4 - Ranking" << endl;
		cout << "5 - Salida" << endl;
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
	}

	do{
	cout << "Introduzca la opción: ";
	cin >> opcion;
	if(opcion == 666)
		trollface();
	if(opcion < 1 || (unlock1 == 0 && opcion > 3 && opcion != 666) || (unlock1 == 1 && unlock2 == 0 && opcion > 4 && opcion != 666) || (unlock2 == 1 && opcion > 5 && opcion != 666))
			cout << "Error en el número de la opción" << endl;
	}while(opcion < 1 || (unlock1 == 0 && opcion > 3) || (unlock1 == 1 && unlock2 == 0 && opcion > 4) || (unlock2 == 1 && opcion > 5));

	return(opcion);
}

int veinteOperaciones(TRanking1 &ranking){
	system("clear");

	int nivel = 0; //Variable que guarda el avance respuestas acertadas. Si aciertas aumenta en 1 y si fallas decrementa
	int incorrectas = 0; //Guarda el número de respuestas incorrectas
	int tiempofinal = 0; //Guarda el tiempo en el que resuelves las operaciones (con su error añadido)
	srand (time(NULL));
	char operador = ' '; //Guarda el operador que tiene una operación
	int i = 0; //Guarda el número de operaciones
	int numero1 = 0;//Guarda el primer número de la operación
	int numero2 = 0;//Guarda el segundo número de la operación
	int operacion = 0;//Guarda el tipo de operación (suma, resta, multiplicación o división) en forma númérica (0,1,2,3)
	int resultado = 0;//Guarda el resultado de la operación
	time_t diferencia; //Tiempo en el que se resuelven las operaciones

	time_t t1; //Tiempo del sistema al iniciar el minijuego
	t1 = time(NULL);

	do{
		if(nivel < 4){
			numero1 = rand () % 21;
			numero2 = rand() % 21;
			operacion = rand() % 2;
		}

		else if(nivel < 8){
			numero1 = rand () % 16;
			numero2 = rand() % 16;
			operacion = rand() % 3;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand () % 91;
					numero2 = rand() % 40 + 1;
				}
			}
		}
		else if(nivel < 12){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 2;
		}
		else if(nivel < 16){
			numero1 = rand () % 16;
			numero2 = rand() % 21;
			operacion = rand() % 3;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
		}
		else if(nivel < 20){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 4;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
			else if(operacion == 3){
					numero1 = rand () % 91;
					numero2 = rand() % 41;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 91;
					numero2 = rand() % 40 + 1;
				}
			}
		}

		if(operacion == 0)
			operador = '+';
		else if(operacion == 1)
			operador = '-';
		else if(operacion == 2)
			operador = '*';
		else if(operacion == 3)
			operador = '/';

		cout << numero1 << " " << operador << " " << numero2 << " = ";

		cin >> resultado;

		if(operacion == 0){
			if(numero1 + numero2 != resultado){
				cout << "X \a" << endl;
				incorrectas++;
				nivel = nivel-2;
			}
			else
				cout << "✔" << endl;
		}
		else if(operacion == 1){
			if(numero1 - numero2 != resultado){
				cout << "X \a" << endl;
				incorrectas++;
				nivel = nivel-2;
			}
			else
				cout << "✔" << endl;
		}
		else if(operacion == 2){
			if(numero1 * numero2 != resultado){
				cout << "X \a" << endl;
				incorrectas++;
				nivel = nivel-2;
			}
			else
				cout << "✔" << endl;
		}
		else if(operacion == 3){
			if(numero1 / numero2 != resultado){
				cout << "X \a" << endl;
				incorrectas++;
				nivel = nivel-2;
			}
			else
				cout << "✔" << endl;
		}

		i++;
		nivel++;

	}while(i < 20);
	time_t t2;//Tiempo del sistema al finalizar
	t2 = time(NULL);

	diferencia = difftime(t2,t1);

	tiempofinal = diferencia + (5*incorrectas);

	cout << endl << "Tu tiempo ha sido de " << tiempofinal << " segundos (" << diferencia << " segundos más 5 por cada error)" << endl;

	wait (5);

	gestionarRanking1(tiempofinal,ranking);

	return tiempofinal;

}

float operacionesContrarreloj(TRanking2 &ranking2){
	system("clear");
	float eficacia = 0;//Guarda la eficacia (operaciones/segundo) al final del minijuego
	int puntuacion = 0;//Guarda la puntuación final del minijuego
	int tiempointroducido = 0; //Guarda el tiempo que introduce el usuario que será el que hará que dure el minijuego
	int tiempointroducidoconerrores = 0; //Guarda el tiempo con los errores del usuario
	int nivel = 0; //Mismas variables que con el minijuego anterior
	srand (time(NULL));
	char operador = ' ';
	int i = 0;
	int incorrectas = 0;
	int numero1 = 0;
	int numero2 = 0;
	int operacion = 0;
	int resultado = 0;

	cout << "Introduzca el tiempo de juego: ";
	cin >> tiempointroducido;

	time_t t1;
	time_t t2;
	t1 = time(NULL);

	do{
		if(nivel < 4){
			numero1 = rand () % 21;
			numero2 = rand() % 21;
			operacion = rand() % 2;
		}

		else if(nivel < 8){
			numero1 = rand () % 16;
			numero2 = rand() % 16;
			operacion = rand() % 3;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
		}
		else if(nivel < 12){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 2;
		}
		else if(nivel < 16){
			numero1 = rand () % 16;
			numero2 = rand() % 21;
			operacion = rand() % 3;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
		}
		else if(nivel < 20){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 4;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
			else if(operacion == 3){
					numero1 = rand () % 91;
					numero2 = rand() % 41;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 91;
					numero2 = rand() % 40 + 1;
				}
			}

		}
		else if(nivel >= 20){
			numero1 = rand () % 91;
			numero2 = rand() % 91;
			operacion = rand() % 4;
			if(operacion == 2){
				while(numero1 * numero2 > 120){
					numero1 = rand() % 12;
					numero2 = rand() % 12;
				}
			}
			else if(operacion == 3){
					numero1 = rand () % 151;
					numero2 = rand() % 91;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 151;
					numero2 = rand() % 90 + 1;
				}
			}
		}

		if(operacion == 0)
			operador = '+';
		else if(operacion == 1)
			operador = '-';
		else if(operacion == 2)
			operador = '*';
		else if(operacion == 3)
			operador = '/';

		cout << numero1 << " " << operador << " " << numero2 << " = ";
		cin >> resultado;

		if(operacion == 0){
			t2 = time(NULL);
			if(difftime(t2,t1) < tiempointroducido){
				if(numero1 + numero2 != resultado){
					cout << "X \a" << endl;
					incorrectas++;
					nivel = nivel-2;
				}
				else{
					cout << "✔" << endl;
					puntuacion += ((nivel/4)+1)*100;
				}
			}
			else
				cout << "X" << endl;
		}
		else if(operacion == 1){
			t2 = time(NULL);
			if(difftime(t2,t1) < tiempointroducido){
				if(numero1 - numero2 != resultado){
					cout << "X \a" << endl;
					incorrectas++;
					nivel = nivel-2;
				}
				else{
					cout << "✔" << endl;
					puntuacion += ((nivel/4)+1)*100;
				}
			}
			else
				cout << "X" << endl;
		}
		else if(operacion == 2){
			t2 = time(NULL);
			if(difftime(t2,t1) < tiempointroducido){
				if(numero1 * numero2 != resultado){
					cout << "X \a" << endl;
					incorrectas++;
					nivel = nivel-2;
				}
				else{
					cout << "✔" << endl;
					puntuacion += ((nivel/4)+1)*100;
				}
			}
			else
				cout << "X" << endl;
		}

		else if(operacion == 3){
			t2 = time(NULL);
			if(difftime(t2,t1) < tiempointroducido){
				if(numero1 / numero2 != resultado){
					cout << "X \a" << endl;
					incorrectas++;
					nivel = nivel-2;
				}
				else{
					cout << "✔" << endl;
					puntuacion += ((nivel/4)+1)*100;
				}
			}
			else
				cout << "X" << endl;
		}




		if(difftime(t2,t1) < tiempointroducido){
			i++;
			nivel++;
		}

		else
			cout << "La última operación está fuera de tiempo" << endl;


	}while(difftime(t2,t1) < tiempointroducido);

	tiempointroducidoconerrores = tiempointroducido + (5*incorrectas);

	eficacia = (float)i/(float)tiempointroducidoconerrores;


	cout << endl << "Has resuelto " << i << " operaciones en " << tiempointroducidoconerrores << " segundos (" << tiempointroducido << " segundos más 5 segundos por error), con una media de " << eficacia << " operaciones por segundo. Tu puntuación es " << puntuacion << " puntos." << endl;

	wait (5);

	gestionarRanking2(tiempointroducidoconerrores,eficacia,i,puntuacion,ranking2);

	return(eficacia);
}

float maratonOperaciones(TRanking2 &ranking3){
	system("clear");

	float eficacia = 0;
	bool correcto = 1; //Controla cuando el usuario se equivoca y para el minijuego
	srand (time(NULL));
	char operador = ' ';
	int puntuacion = 0;
	int i = 0;
	int numero1 = 0;
	int numero2 = 0;
	int operacion = 0;
	int resultado = 0;
	time_t diferencia;

	time_t t1;
	t1 = time(NULL);

	do{
		if(i < 4){
			numero1 = rand () % 21;
			numero2 = rand() % 21;
			operacion = rand() % 2;
		}

		else if(i < 8){
			numero1 = rand () % 16;
			numero2 = rand() % 16;
			operacion = rand() % 3;
		}
		else if(i < 12){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 2;
		}
		else if(i < 16){
			numero1 = rand () % 16;
			numero2 = rand() % 21;
			operacion = rand() % 3;
		}
		else if(i < 20){
			numero1 = rand () % 41;
			numero2 = rand() % 41;
			operacion = rand() % 4;
			if(operacion == 3){
					numero1 = rand () % 91;
					numero2 = rand() % 41;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 91;
					numero2 = rand() % 40 + 1;
				}
			}
		}
		else if(i < 30){
			numero1 = rand () % 91;
			numero2 = rand() % 91;
			operacion = rand() % 4;
			if(operacion == 3){
					numero1 = rand () % 141;
					numero2 = rand() % 91;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 141;
					numero2 = rand() % 90 + 1;
				}
			}
		}
		else if(i >= 30){
			numero1 = rand () % 141;
			numero2 = rand() % 141;
			operacion = rand() % 4;
			if(operacion == 3){
					numero1 = rand () % 191;
					numero2 = rand() % 141;
				while(numero1 % numero2 != 0){
					numero1 = rand () % 191;
					numero2 = rand() % 140 + 1;
				}
			}
		}

		if(operacion == 0)
			operador = '+';
		else if(operacion == 1)
			operador = '-';
		else if(operacion == 2)
			operador = '*';
		else if(operacion == 3)
			operador = '/';

		cout << numero1 << " " << operador << " " << numero2 << " = ";


		cin >> resultado;
		correcto = 1;

		if(operacion == 0){
			if(numero1 + numero2 != resultado){
				cout << "X \a" << endl;
				correcto = 0;

			}
			else{
				cout << "✔" << endl;
				puntuacion += ((i/4)+1)*100;
			}
		}
		else if(operacion == 1){
			if(numero1 - numero2 != resultado){
				cout << "X \a" << endl;
				correcto = 0;
			}
			else{
				cout << "✔" << endl;
				puntuacion += ((i/4)+1)*100;
			}
		}
		else if(operacion == 2){
			if(numero1 * numero2 != resultado){
				cout << "X \a" << endl;
				correcto = 0;
			}
			else{
				cout << "✔" << endl;
				puntuacion += ((i/4)+1)*100;
			}
		}
		else if(operacion == 3){
			if(numero1 / numero2 != resultado){
				cout << "X \a" << endl;
				correcto = 0;
			}
			else{
				cout << "✔" << endl;
				puntuacion += ((i/4)+1)*100;
			}
		}


		i++;

	}while(correcto == 1);
	i--;
	time_t t2;
	t2 = time(NULL);

	diferencia = difftime(t2,t1);

	eficacia = (float)i/(float)diferencia;


		cout << endl << "Has resuelto " << i << " operaciones en " << diferencia << " segundos, con una media de " << eficacia << " operaciones por segundo. Tu puntuación es " << puntuacion << " puntos." << endl;


	wait (5);

	gestionarRanking3(diferencia,eficacia,i,puntuacion,ranking3);

	return puntuacion;

}

void menuRanking(TRanking1 ranking, TRanking2 ranking2, TRanking2 ranking3, bool unlock1, bool unlock2,char estiloMenu){


	if(unlock1 == 0)
		mostrarRanking(ranking,ranking2,ranking3,1,estiloMenu);
	else if(unlock1 == 1 && unlock2 == 0){
		system("clear");

		int opcion = 0;
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

		cout << "Seleccione juego para ver puntuaciones: "<< endl;
		cout << "1 - 20 operaciones muy rápidas" << endl;
		cout << "2 - Operaciones a contrarreloj" << endl;
		cout << "3 - Volver al menú" << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

		do{
			cout << "Introduzca la opción: ";
			cin >> opcion;

			if(opcion < 1 || opcion > 3)
				cout << "Error en el número de la opción" << endl;
			else if(opcion == 1)
				mostrarRanking(ranking,ranking2,ranking3,1,estiloMenu);
			else if(opcion == 2)
				mostrarRanking(ranking,ranking2,ranking3,2,estiloMenu);
		}while(opcion < 1 || opcion > 3);
	}

	else if(unlock2 == 1){
		system("clear");

		int opcion = 0;
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

		cout << "Seleccione juego para ver puntuaciones: "<< endl;
		cout << "1 - 20 operaciones muy rápidas" << endl;
		cout << "2 - Operaciones a contrarreloj" << endl;
		cout << "3 - Maratón de operaciones" << endl;
		cout << "4 - Volver al menú" << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

		do{
			cout << "Introduzca la opción: ";
			cin >> opcion;

			if(opcion < 1 || opcion > 4)
				cout << "Error en el número de la opción" << endl;
			else if(opcion == 1)
				mostrarRanking(ranking,ranking2,ranking3,1,estiloMenu);
			else if(opcion == 2)
				mostrarRanking(ranking,ranking2,ranking3,2,estiloMenu);
			else if(opcion == 3)
				mostrarRanking(ranking,ranking2,ranking3,3,estiloMenu);
		}while(opcion < 1 || opcion > 4);
	}
}

void trollface(){
	cout <<
"                                    ,:rvu2P0MMBBBBBBBBBBBBBBBBBBBBBBBBBBBBBEJ.                      " << endl <<
"                          ,rLNBBBBBBBBBBBBBBMBMMMMOMOMOME0kk251PP0NZN8ZOMBBBBBBY                    " << endl <<
"                   rGBBBBBBBBBBXU7r::,,.,..........      ....                :BBBO                  " << endl <<
"               iMBBBBN7i..         . .                        .i7Jr,            PBBF                " << endl <<
"            ,OBBB0: .:,.:,:,,,,...... ..,,:ir7Lr7i:,:,::ii;ii::.  .;5U;           BBB               " << endl <<
"          :BBBP.    :            ...,:,,.,..       ..,.,.....,,::i:.  ,jJi         2BB.             " << endl <<
"         BBBi          :77L77rr::,,.              OJ:,,,:,::i;v77ii:i7i  :J7,       7BB.            " << endl <<
"        BBq         :PF7.      ..:,r.            BJ              :ijv:.vj.  v1:      7BB            " << endl <<
"        BB         qZ.            N             r0                  .J5. 50   :       UBB           " << endl <<
"       rBB        :E              1U            ,        .             Fu ,J           MBB          " << endl <<
"       BBv                         7                :0BBBBBBBBBBBBMU:                   BBB.        " << endl <<
"     iBBP            iFOMBMM0SL:                 .NBBBEi  BBBBBBBBBBBB2                  UBB1       " << endl <<
"   7BBB.   .....i: rBBBBBBBBBBBBBM:            .BBBJ      EBBBBBBBBF:SBBr  :L7.      .ii;iBBBBj     " << endl <<
"  BBB:  Y;:iirr7Lr :MBBBBBBBBBBBBBBBN5X2       BBB   iBBBBBB0j7L1ZBBBBBBj .:UU         .:ri7JOBB:   " << endl <<
" MBq  uY...                 .,ruMBBBBBBU        BBBBBBBF:    N2           ,   .uBBBBBBP:    .YiBBO  " << endl <<
"LBB JL 71:   ,,.                  5BB             SMi        UBBBi        .jBBBBBJrUXBBBBS    X FBB " << endl <<
"BBj:7 .E 7BBBBBBBB0.    .         LB1                          LBBBBBBBBBBBBBu.   .     BBB   .2 LBB" << endl <<
"BB7L  U, BB;     BBBBOBBBu        BBY                             :UkEqF7:       BB.     SBB   q  5B" << endl <<
"BB7r  E       :Y  kBBBBF:      :BBBN             ..                           1BBBBB      BBL  P   B" << endl <<
"8BP:i Y0      BB             uBBB;              iBBBBB.LN:,,.,..          iBBBBB;.BBBBq7  iBq  E   B" << endl <<
" BBiq  :0    MBBi         .OBBBB                    rBB .:iirrvr      iSBBBBq.    BBBBBBL BBi .k  uB" << endl <<
" :BB,7Y,    5BBBB      7YYUNBBBBB         :BBBBBBB  :BB          iFBBBBBBY       BBZ     2BB  Y7  BB" << endl <<
"  1BB  ijY  BB2MBB:   Yi       YBBU   .    ,,  .12 LBB     .Y8BBBBBB2,BB       7BBB7     BB  iZ  BBv" << endl <<
"   ZBB      BBYBBBBBU.           MBBBBBN            , .jMBBBBBMY,     BB   ,5BBBBBU       .iJi .BB2 " << endl <<
"    BBj    ,BBBB :BBBBBML,         .i,        :rSMBBBBBBBq:         ,BBBYBBBBNBBB:       ::   GBBi  " << endl <<
"    :BB    rBBB2 YBY .5BBBBBBBBBG1vY20MBBBBBBBBBBB0j:  BB         :BBBBBBBj  7BB           .BBBB    " << endl <<
"     BB    rBBB  OB.   GBM,:vUEBBBBBB8NUL;BBB.         iBO   iqBBBBBBBBB.   MBB            MBB:     " << endl <<
"     BB    7BBBBUBB0   BB        BB       7Bi          :BBOBBBBBBBBJ LBO  .BBq           .BBN       " << endl <<
"     BB    :BBBBBBBBB1XBBL;:,.  ,BB.      MB2  .,:L5MBBBBBBBBBBY,     BB uBBi           .BBY        " << endl <<
"     BB    ,BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB7          rBBB8             BB2         " << endl <<
"     BB     BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBSi   BB          7BBB.             BBO          " << endl <<
"     BB     BB7uBBMBBBBBBBBBBBBBBBBBBBBBBBBBBBBi.        8BB      .BBBM.             .BB0           " << endl <<
"     BB     .BB NBv BBM.YqBBBqZ08BBBu,,..   2BY           BB1   uBBBX               XBB7            " << endl <<
"     BB      7BB7B0  BB   jB8     BB        iBU            BBBBBBBi               vBBB              " << endl <<
"    .BB       iBBB7  .BB   BBL    YB0       :BE        .7XBBBBBr     :v;.  :Li  7BBB:               " << endl <<
"    .BB         iBBBBBBBBY,PBBU   ,BB       FBBrr20BBBBBBBEr     .ru7,  :u7.  YBBBi                 " << endl <<
"    :BB             :7uPBBBBBBBBBBBBBBBBBBBBBBBBBBBMFr,       iLL:. .iLi   iBBBB:                   " << endl <<
"    iB8        .7                      .                 .iL7i.  :r7.   iBBBBY                      " << endl <<
"    JBX   .:    rM2.                                .,rr7::..,;i,    UBBBBY                         " << endl <<
"    qB;    Bi     :21Yi,             ....,.,.:,::;rLv7;i::::     UBBBBBr                            " << endl <<
"    BB.     k0J.      ::i:ii;ir;r;rii:i:::i:rrLYJYLri::.     7BBBBBY.                               " << endl <<
"    BBr       iXPY:.         . ......:,::ii;::,.         iMBBBBU.                                   " << endl <<
"    rBB.         ,iii:i:i::::::::,,....              .FBBBBq:                                       " << endl <<
"     YBBi                                        :UBBBBB7                                           " << endl <<
"      :BBB:                              .rUBBBBBBBBU.                                              " << endl <<
"        uBBBN:                     :YMBBBBBBBBXYi.                                                  " << endl <<
"           7BBBBBGNFS5SFkXEZMBBBBBBBB0Y:                                                            " << endl;
}

void mostrarRanking(TRanking1 ranking,TRanking2 ranking2,TRanking2 ranking3,int tipo, char estiloMenu){
	system("clear");
	if (tipo == 1){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

		cout << "Récords en 20 operaciones muy rápidas" << endl;
		for(int i = 0; i< kNUMRANKING; i++)
			cout << i + 1 << ": " << ranking[i].nick << ", " << ranking[i].tiempo << " segundos." << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;

	}
	else if (tipo == 2){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;


		cout << "Récords en operaciones a contrarreloj" << endl;
		for(int i = 0; i< kNUMRANKING; i++)
			cout << i + 1 << ": " << ranking2[i].nick << ", " << ranking2[i].eficacia << " operaciones/segundo, " << ranking2[i].numoperaciones << " operaciones, " << ranking2[i].tiempo << " segundos, " << ranking2[i].puntuacion << " puntos." << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
	}

	else if (tipo == 3){
		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;


		cout << "Récords en maratón de operaciones" << endl;
		for(int i = 0; i< kNUMRANKING; i++)
			cout << i + 1 << ": " << ranking3[i].nick << ", " << ranking3[i].puntuacion << " puntos, " << ranking3[i].eficacia << " operaciones/segundo, " << ranking3[i].numoperaciones << " operaciones, " << ranking3[i].tiempo << " segundos." << endl;

		for(int i=0;i<60; i++)
			cout << estiloMenu;
		cout << endl;
	}

	wait(5);
}

void gestionarRanking1(int tiempo,TRanking1 &ranking){
	TRankingRecord1 partida;
	partida.tiempo = tiempo;
	string nombre;
	int i = kNUMRANKING;
	bool check = 0;

	do{
		i--;
		if(ranking[i].tiempo > partida.tiempo || ranking[i].tiempo == 0){
			if(i < kNUMRANKING-1)
				ranking[i+1] = ranking[i];
		}
		else{
			check = 1;
			i++;
		}
	}while(check == 0 && i > 0);

	if(i < kNUMRANKING){
		cout << "¡Has superado un récord! Introduce tu nombre: ";
		cin >> nombre;
		partida.nick = nombre;
		ranking[i] = partida;
	}

}

void gestionarRanking2(int tiempo, float eficacia, int operaciones,int puntuacion,TRanking2 &ranking2){
	TRankingRecord2 partida;
	partida.tiempo = tiempo;
	partida.eficacia = eficacia;
	partida.numoperaciones = operaciones;
	partida.puntuacion = puntuacion;
	string nombre;
	int i = kNUMRANKING;
	bool check = 0;

	do{
		i--;
		if(ranking2[i].eficacia < partida.eficacia){
			if(i < kNUMRANKING-1)
				ranking2[i+1] = ranking2[i];
		}
		else{
			check = 1;
			i++;
		}
	}while(check == 0 && i > 0);

	if(i < kNUMRANKING){
		cout << "¡Has superado un récord! Introduce tu nombre: ";
		cin >> nombre;
		partida.nick = nombre;
		ranking2[i] = partida;
	}

}

void gestionarRanking3(int tiempo, float eficacia, int operaciones,int puntuacion,TRanking2 &ranking3){
	TRankingRecord2 partida;
	partida.tiempo = tiempo;
	partida.eficacia = eficacia;
	partida.numoperaciones = operaciones;
	partida.puntuacion = puntuacion;
	string nombre;
	int i = kNUMRANKING;
	bool check = 0;

	do{
		i--;
		if(ranking3[i].puntuacion < partida.puntuacion){
			if(i < kNUMRANKING-1)
				ranking3[i+1] = ranking3[i];
		}
		else{
			check = 1;
			i++;
		}
	}while(check == 0 && i > 0);

	if(i < kNUMRANKING){
		cout << "¡Has superado un récord! Introduce tu nombre: ";
		cin >> nombre;
		partida.nick = nombre;
		ranking3[i] = partida;
	}

}

void guardarDatos(TRanking1 ranking, TRanking2 ranking2, TRanking2 ranking3, bool unlock1, bool unlock2, bool unlock3){
	ofstream fo;
	bool error = 0;
	char guardado;

	do{
		error = 0;
		fo.open("saves/ranking1.txt",ios::out);
		if(fo.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fo << ranking[i].nick << " " << ranking[i].tiempo << endl;
			}
			fo.close();
		}

		else{
			cout << "No se ha podido crear/abrir el archivo ranking1.txt (¿existe la carpeta 'saves'?). No se guardarán los datos." << endl;
			error = 1;
		}
		fo.open("saves/ranking2.txt",ios::out);

		if(fo.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fo << ranking2[i].nick << " " << ranking2[i].tiempo << " " << ranking2[i].eficacia << " " << ranking2[i].numoperaciones << " " << ranking2[i].puntuacion << endl;
			}
			fo.close();
		}

		else{
			cout << "No se ha podido crear/abrir el archivo ranking2.txt (¿existe la carpeta 'saves'?). No se guardarán los datos." << endl;
			error = 1;
		}

		fo.open("saves/ranking3.txt",ios::out);
		if(fo.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fo << ranking3[i].nick << " " << ranking3[i].tiempo << " " << ranking3[i].eficacia << " " << ranking3[i].numoperaciones << " " << ranking3[i].puntuacion << endl;
			}
			fo.close();
		}

		else{
			cout << "No se ha podido crear/abrir el archivo ranking3.txt (¿existe la carpeta 'saves'?). No se guardarán los datos." << endl;
			error = 1;
		}

		fo.open("saves/savedata.txt",ios::out);
		if(fo.is_open())
		{
			fo << unlock1 << " " << unlock2 << " " << unlock3 << endl;
			fo.close();
		}

		else{
			cout << "No se ha podido crear/abrir el archivo savedata.txt. No se guardarán los datos (¿existe la carpeta 'saves'?)." << endl;
			error = 1;
		}
		if(error == 1){
			do{
				cout << endl << "¿Quieres reintentar el guardado? [y/n]: ";
				cin >> guardado;
			}while(guardado != 'y' && guardado != 'n');
		}
	}while(error == 1 && guardado == 'y');

	cout << "Guardando..." << endl;
	wait(2);

	cout << "Datos guardados satisfactoriamente" << endl;
}

void cargarDatos(TRanking1 &ranking, TRanking2 &ranking2, TRanking2 &ranking3, bool &unlock1, bool &unlock2, bool &unlock3){
	ifstream fi;
	bool error = 0;
	bool error1 = 0;
	bool error2 = 0;
	bool error3 = 0;
	bool error4 = 0;
	char cargado = ' ';

	do{
		error = 0;
		fi.open("saves/ranking1.txt",ios::in);
		if(fi.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fi >> ranking[i].nick;
				fi >> ranking[i].tiempo;
			}
			fi.close();
		}

		else{
			cout << "No se ha podido abrir el archivo ranking1.txt (¿existe la carpeta 'saves'?). No se cargarán los datos." << endl;
			error = 1;
			error1 = 1;
		}
		fi.open("saves/ranking2.txt",ios::in);

		if(fi.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fi >> ranking2[i].nick;
				fi >> ranking2[i].tiempo;
				fi >> ranking2[i].eficacia;
				fi >> ranking2[i].numoperaciones;
				fi >> ranking2[i].puntuacion;
			}
			fi.close();
		}

		else{
			cout << "No se ha podido abrir el archivo ranking2.txt (¿existe la carpeta 'saves'?). No se cargarán los datos." << endl;
			error = 1;
			error2 = 1;
		}

		fi.open("saves/ranking3.txt",ios::in);
		if(fi.is_open())
		{
			for(int i =0; i<kNUMRANKING; i++){
				fi >> ranking3[i].nick;
				fi >> ranking3[i].tiempo;
				fi >> ranking3[i].eficacia;
				fi >> ranking3[i].numoperaciones;
				fi >> ranking3[i].puntuacion;
			}
			fi.close();
		}

		else{
			cout << "No se ha podido abrir el archivo ranking3.txt (¿existe la carpeta 'saves'?). No se cargarán los datos." << endl;
			error = 1;
			error3 = 1;
		}

		fi.open("saves/savedata.txt",ios::in);
		if(fi.is_open())
		{
			fi >> unlock1;
			fi >> unlock2;
			fi >> unlock3;
			fi.close();
		}

		else{
			cout << "No se ha podido abrir el archivo savedata.txt (¿existe la carpeta 'saves'?). No se cargarán los datos." << endl;
			error = 1;
			error4 = 1;
		}
		if(error == 1){
			do{
				cout << endl << "¿Quieres reintentar la carga? Si pulsas [y] se reintentará la carga. Si pulsas [n] se crearán archivos nuevos (asegúrate de crear la carpeta saves o no se crearán archivos): ";
				cin >> cargado;
			}while(cargado != 'y' && cargado != 'n');
		}
	}while(error == 1 && cargado == 'y');

	if(cargado == 'n'){
		ofstream fo;
		if(error1 == 1){
			fo.open("saves/ranking1.txt",ios::out);
			if(fo.is_open())
				fo.close();
		}
		if(error2 == 1){
			fo.open("saves/ranking2.txt",ios::out);
			if(fo.is_open())
				fo.close();
		}
		if(error3 == 1){
			fo.open("saves/ranking3.txt",ios::out);
			if(fo.is_open())
				fo.close();
		}
		if(error4 == 1){
			fo.open("saves/savedata.txt",ios::out);
			if(fo.is_open())
				fo.close();
		}
		cout << "Creando archivos faltantes..." << endl;
		wait (2);
		cout << "Archivos creados satisfactoriamente" << endl;
		wait(1);
	}

	if(cargado == ' '){
		cout << "Cargando..." << endl;
		wait(2);

		cout << "Datos cargados satisfactoriamente" << endl;
		wait(1);
	}
}
